"""
Django settings for lingualibre project.

Generated by 'django-admin startproject' using Django 4.2.6.

For more information on this file, see
https://docs.djangoproject.com/en/4.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.2/ref/settings/
"""

import sys
from pathlib import Path
import configparser
import os

# Read the config file
config = configparser.ConfigParser()
config.read(os.path.dirname(__file__) + "/../config.ini")

is_production = config.getboolean("deployment", "production")
is_beta_cluster = config.getboolean("deployment", "betacluster")
is_localhost = config.getboolean("deployment", "localhost")
if not (is_production or is_beta_cluster or is_localhost):
    raise RuntimeError(
        "At least one of the values in [deployment] in config.ini should be set to yes")

is_internet_facing = is_production or is_beta_cluster

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

MEDIA_ROOT = BASE_DIR / "media"

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = config.get('security', 'django_secret_key')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = not is_internet_facing

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

    'rest_framework',
    'social_django',
    'corsheaders',

    'locutors',
    'user_profile',
    'upload_batches',
    'lingualibre'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'social_django.middleware.SocialAuthExceptionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
]

ROOT_URLCONF = 'lingualibre.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'social_django.context_processors.backends',
                'social_django.context_processors.login_redirect',
            ],
        },
    },
]

WSGI_APPLICATION = 'lingualibre.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',  # MySQL backend is shared with MariaDB
        'NAME': config.get("database", "name"),
        'USER': config.get("database", "user"),
        'PASSWORD': config.get('database', "password"),
        'HOST': config.get('database', 'host'),
        'PORT': config.get('database', 'port', fallback=''),
        'OPTIONS': {
            'charset': 'utf8mb4',
        },
    }
}

# somehow MariaDB on Toolforge will not handle unicode properly without the following two lines
# Ref: https://wikitech.wikimedia.org/wiki/Help:Toolforge/My_first_Django_OAuth_tool#:~:text=connection%20as%20follows%3A-,DATABASES,-%3D%20%7B%0A%20%20%20%20%27default
if is_internet_facing:
    DATABASES['default']['OPTIONS']['init_command'] = "SET sql_mode='STRICT_TRANS_TABLES'"
    DATABASES['default']['OPTIONS']['read_default_file'] = os.path.expanduser("~/replica.my.cnf")

# Couldn't get MariaDB to work for tests in Gitlab CI,
# So we'll just use SQLite when running tests
if 'test' in sys.argv:
    DATABASES['default'] = {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': 'lingualibre'
    }

# Password validation
# https://docs.djangoproject.com/en/4.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Social Authentication
AUTHENTICATION_BACKENDS = (
    'social_core.backends.mediawiki.MediaWiki',
    'django.contrib.auth.backends.ModelBackend',
)

AUTH_USER_MODEL = 'user_profile.User'

# Workaround for https://github.com/python-social-auth/social-core/issues/690
SOCIAL_AUTH_PROTECTED_USER_FIELDS = ['groups']

SOCIAL_AUTH_MEDIAWIKI_KEY = config.get("oauth", "key")
SOCIAL_AUTH_MEDIAWIKI_SECRET = config.get("oauth", "secret")
SOCIAL_AUTH_MEDIAWIKI_URL = config.get("oauth", "provider_url")

SOCIAL_AUTH_MEDIAWIKI_CALLBACK = 'http://127.0.0.1:8080/oauth/complete/mediawiki/'  # Localhost
if is_beta_cluster:
    # Beta cluster so dev.lingualibre.org
    SOCIAL_AUTH_MEDIAWIKI_CALLBACK = 'https://dev.lingualibre.org/oauth/complete/mediawiki/'


LOGIN_REDIRECT_URL = 'http://127.0.0.1:8079'  # Localhost
if is_beta_cluster:
    # Beta cluster so dev.lingualibre.org
    LOGIN_REDIRECT_URL = 'https://dev.lingualibre.org'

SESSION_COOKIE_HTTPONLY = False

# Internationalization
# https://docs.djangoproject.com/en/4.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.2/howto/static-files/

STATIC_URL = 'static/'
STATIC_ROOT = os.path.join(BASE_DIR, "static")

# Default primary key field type
# https://docs.djangoproject.com/en/4.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

# CORS (Cross-Origin Resource Sharing)
ALLOWED_HOSTS = [
    '127.0.0.1',
    '127.0.0.1:8079',
    'lingualibre.org',
    'dev.lingualibre.org',
    'toolforge.org',
    'lingua-libre.toolforge.org'
]

CSRF_TRUSTED_ORIGINS = [
    'http://127.0.0.1:8079',
    'https://lingualibre.org',
    'https://dev.lingualibre.org',
    'https://toolforge.org',
    'https://lingua-libre.toolforge.org'
]

CORS_ORIGIN_ALLOW_ALL = True
CORS_ALLOW_CREDENTIALS = True
SESSION_COOKIE_SAMESITE = False
